<template src="./template.html"></template>
<script lang="ts">
// import { getModule } from "nuxt-property-decorator";
import _, { cloneDeep } from "lodash";
import { Watch } from "nuxt-property-decorator";
import { title } from "process";
import { Vue, Component, Prop } from "vue-property-decorator";
import { api } from "~/common/constaint";
import { apiErrorHandler } from "~/utils/apiHanlers";
import { getTimeZone, getUnixFrom, getUnixTo } from "~/utils/timeZone";
var momentz = require("moment-timezone");
var moment = require("moment");
// import axios from "axios";
// import UserModule from "~/store/user";
// import { Store } from "vuex";
@Component({
  components: {
    StoreOrder: () => import("@/components/Seller/Store/StorerOrder/index.vue"),
    SettingProduct: () => import("@/components/Seller/Store/Setting/index.vue"),
    EmptyData: () => import("@/components/Utils/EmptyData/index.vue"),
    LoadingComponent: () => import("@/components/Utils/Loading/index.vue"),
  },
})
export default class DetailSellerStoreComponent extends Vue {
  tab = 0;
  tabTitle = [
    {
      title: "Store Overview",
      icon: "mdi-monitor-dashboard",
    },
    {
      title: "Store Orders",
      icon: "mdi-view-list",
    },
    {
      title: "Store Settings",
      icon: "mdi-cog",
    },
  ];

  settings: any = {};
  limitItems = [5, , 10, , 15, , 20, , 25, , 30, , 35, , 40];
  storeId = "";

  tableHeader = [
    { name: "Order ID" },
    { name: "Customer" },
    { name: "Paid Time" },
    { name: "Amount" },
    { name: "Status" },
  ];
  config = {
    page: 1,
    limit: 25,
    search: "",
  };
  totalPage: number = 1;
  page = 1;
  dialogCancelChange = false;
  get dateStart() {
    return this.$store.state?.sellerStore.dateStart || "";
  }

  set dateStart(value: string) {
    this.$store.commit("sellerStore/setDateStart", value);
  }

  get dateEnd() {
    return this.$store.state?.sellerStore.dateEnd || "";
  }

  set dateEnd(value: any) {
    this.$store.commit("sellerStore/setDateEnd", value);
  }
  get isNotChangeListMinimum() {
    return this.$store.state.sellerStore.isNotChangeListMinimum;
  }
  set isNotChangeListMinimum(value: any) {
    this.$store.commit("sellerStore/setIsNotChangeListMinimum", value);
  }

  get stats() {
    return this.$store.state.manageStats.stats;
  }

  set stats(value: any) {
    this.$store.commit("manageStats/setStats", value);
  }

  get store() {
    return this.$store.state?.sellerStore?.store || {};
  }

  set store(value: any) {
    this.$store.commit("sellerStore/setStore", value);
  }

  get pixel() {
    return this.$store.state?.sellerStore?.pixel || {};
  }

  set pixel(value: any) {
    this.$store.commit("sellerStore/setPixel", value);
  }

  get cloneStore() {
    return this.$store.state?.sellerStore?.cloneStore || {};
  }

  get clonePixel() {
    return this.$store.state?.sellerStore?.clonePixel || {};
  }

  set clonePixel(value: any) {
    this.$store.commit("sellerStore/setClonePixel", value);
  }

  get isNotChangeStore() {
    return this.$store.state?.sellerStore?.isNotChangeStore;
  }

  set isNotChangeStore(value: any) {
    this.$store.commit("sellerStore/setIsNotChangeStore", value);
    // this.$store.dispatch("sellerStore/onSubmitDiscount", {
    //   ctx: this,
    // });
  }

  get isNotChangePixel() {
    return this.$store.state?.sellerStore?.isNotChangePixel;
  }

  get isNotChangeListImage() {
    return this.$store.state?.sellerStore?.isNotChangeListImage;
  }

  get isNotChangeDiscount() {
    return this.$store.state?.sellerStore.isNotChangeDiscount;
  }

  get isNotChangeCheckboxMinimum() {
    return this.$store.state?.sellerStore.isNotChangeCheckboxMinimum;
  }

  set isNotChangeCheckboxMinimum(val: boolean) {
    this.$store.commit("sellerStore/setIsNotChangeCheckboxMinimum", val);
  }

  get isNotChangeMinimumRequire() {
    return this.$store.state?.sellerStore.isNotChangeMinimumRequire || false;
  }

  set isNotChangeMinimumRequire(val: boolean) {
    this.$store.commit("sellerStore/setIsNotChangeMinimumRequire", val);
  }

  set isNotChangeDiscount(val: boolean) {
    this.$store.commit("sellerStore/setIsNotChangeDiscount", val);
  }
  set isNotChangeListImage(value: any) {
    this.$store.commit("sellerStore/setIsNotChangeListImage", value);
  }

  set isNotChangePixel(value: any) {
    this.$store.commit("sellerStore/setIsNotChangePixel", value);
  }

  set cloneStore(value: any) {
    this.$store.commit("sellerStore/setCloneStore", value);
  }

  orderList: any = [];

  get timeActive() {
    return this.$store.state.setting.timeActive;
  }

  set timeActive(value: string) {
    this.$store.commit("setting/setTimeActive", value);
  }

  get timezone() {
    return this.$store.state.setting.timezone;
  }

  get from() {
    return this.$store.state.setting.from;
  }

  get to() {
    return this.$store.state.setting.to;
  }

  get orderDetail() {
    return this.$store.state?.sellerStore?.orderDetail || {};
  }

  get drawer() {
    return this.$store.state?.sellerStore?.drawer || false;
  }

  set drawer(val: any) {
    this.$store.commit("sellerStore/setDrawer", val);
  }

  get loadingFullPage() {
    return this.$store.state.adminProduct.loadingFullPage;
  }

  set loadingFullPage(val: any) {
    this.$store.commit("adminProduct/setLoadingFullPage", val);
  }

  get isChanged() {
    return this.$store.state?.sellerStore.isChanged || false;
  }
  set isChanged(val: boolean) {
    this.$store.commit("sellerStore/setIsChanged", val);
  }

  get cloneDiscount() {
    return this.$store.state?.sellerStore.cloneDiscount || [];
  }
  set cloneDiscount(value: any) {
    this.$store.commit("sellerStore/setCloneDiscount", value);
  }
  get discount() {
    return cloneDeep(this.$store.state?.sellerStore.discount) || [];
  }
  set discount(val: any) {
    this.$store.commit("sellerStore/setDiscount", val);
  }

  get isNotChangeDateStart() {
    return this.$store.state?.sellerStore.isNotChangeDateStart || false;
  }

  set isNotChangeDateStart(value: boolean) {
    this.$store.commit("sellerStore/setIsNotChangeDateStart", value);
  }

  get isNotChangeTimePickerStart() {
    return this.$store.state?.sellerStore.isNotChangeTimePickerStart || false;
  }

  set isNotChangeTimePickerStart(value: any) {
    this.$store.commit("sellerStore/setIsNotChangeTimePickerStart", value);
  }

  get isNotChangeTimePickerEnd() {
    return this.$store.state?.sellerStore.isNotChangeTimePickerEnd || false;
  }

  set isNotChangeTimePickerEnd(value: any) {
    this.$store.commit("sellerStore/setIsNotChangeTimePickerEnd", value);
  }

  get isNotChangeDateEnd() {
    return this.$store.state?.sellerStore.isNotChangeDateEnd || false;
  }

  set isNotChangeDateEnd(value: boolean) {
    this.$store.commit("sellerStore/setIsNotChangeDateEnd", value);
  }
  get isNotChangeShowDateEnd() {
    return this.$store.state?.sellerStore.isNotChangeShowDateEnd;
  }

  set isNotChangeShowDateEnd(value: boolean) {
    this.$store.commit("sellerStore/setIsNotChangeShowDateEnd", value);
  }

  get cloneIsShowDateEnd() {
    return this.$store.state?.sellerStore.cloneIsShowDateEnd;
  }

  set cloneIsShowDateEnd(value: boolean) {
    this.$store.commit("sellerStore/setCloneIsShowDateEnd", value);
  }
  get cloneDateEnd() {
    return this.$store.state?.sellerStore.cloneDateEnd || "";
  }

  set cloneDateEnd(value: any) {
    this.$store.commit("sellerStore/setCloneDateEnd", value);
  }

  get isShowDateEnd() {
    return this.$store.state?.sellerStore.isShowDateEnd;
  }

  set isShowDateEnd(value: boolean) {
    this.$store.commit("sellerStore/setIsShowDateEnd", value);
  }

  get timePickerEnd() {
    return this.$store.state?.sellerStore.timePickerEnd || "";
  }

  set timePickerEnd(value: any) {
    this.$store.commit("sellerStore/setTimePickerEnd", value);
  }
  get cloneTimePickerEnd() {
    return this.$store.state?.sellerStore.cloneTimePickerEnd || "";
  }

  set cloneTimePickerEnd(value: any) {
    this.$store.commit("sellerStore/setCloneTimePickerEnd", value);
  }

  setDiscountToStore() {
    this.$store.commit("sellerStore/setDiscount", this.discount);
    this.isNotChangeDiscount = this.$utils.deepEqual(
      this.discount,
      this.cloneDiscount
    );
  }
  created() {
    this.$store.commit("manageStats/setStatsEachPage", "store-seller");
  }

  createStoreClone() {
    this.$store.commit("sellerStore/setCloneStore");
  }
  createPixelClone() {
    this.$store.commit("sellerStore/setClonePixel");
  }

  createCloneListMinimumRequire() {
    this.$store.commit("sellerStore/setCloneListMinimumRequire");
  }

  async revertChange() {
    try {
      this.loadingFullPage = true;
      this.store = this.cloneStore;
      this.isNotChangeStore = true;
      this.createStoreClone();
      this.pixel = this.clonePixel;
      this.isNotChangePixel = true;
      this.createPixelClone();
      this.isNotChangeListMinimum = true;
      this.isNotChangeDiscount = true;
      this.isNotChangeCheckboxMinimum = true;
      this.isNotChangeMinimumRequire = true;
      this.isNotChangeDateStart = true;
      this.isNotChangeDateEnd = true;
      this.isNotChangeTimePickerStart = true;
      this.isNotChangeTimePickerEnd = true;
      this.isShowDateEnd = this.cloneIsShowDateEnd;
      this.dateEnd = this.cloneDateEnd;
      this.isNotChangeShowDateEnd = true;
      this.timePickerEnd = this.cloneTimePickerEnd;
      this.createCloneListMinimumRequire();
      await this.$store.dispatch("sellerStore/onGetDiscount", {
        ctx: this,
        dontLoading: true,
      });
      this.isChanged = false;
      this.dialogCancelChange = false;
    } catch (error) {
      console.log("error :>> ", error);
    } finally {
      this.loadingFullPage = false;
    }
  }
  changeDiscount() {
    if (Object.keys(this.discount).length > 0) {
      this.$store.dispatch("sellerStore/onSubmitDiscount", {
        ctx: this,
      });
    }
  }
  async saveChange() {
    try {
      this.loadingFullPage = true;
      await Promise.all([
        this.$store.dispatch("sellerStore/onGetAllChanged", {
          ctx: this,
        }),
        this.$store.dispatch("sellerStore/onUpdatePixel", {
          ctx: this,
        }),
        this.$store.dispatch("sellerStore/onSortImage", {
          ctx: this,
        }),
        this.changeDiscount(),
      ]);
      await this.$store.dispatch("sellerStore/onGetDetailStore", { ctx: this }),
        this.$pushNotification.success("Update successfully");
      this.isNotChangeDiscount = true;
      this.isNotChangeStore = true;
      this.isNotChangePixel = true;
      this.isNotChangeListImage = true;
      this.isNotChangeListMinimum = true;
      this.isNotChangeCheckboxMinimum = true;
      this.isNotChangeMinimumRequire = true;
      this.isNotChangeDateStart = true;
      this.isNotChangeDateEnd = true;
      this.dateEnd == this.cloneDateEnd;
      this.isNotChangeTimePickerStart = true;
      this.isNotChangeTimePickerEnd = true;
      this.isNotChangeShowDateEnd = true;
    } catch (error) {
      console.log("error :>> ", error);
      apiErrorHandler(error, this);
    } finally {
      this.loadingFullPage = false;
    }
  }

  async onGetPixcel() {
    try {
      this.$store.commit("sellerStore/setPixel", {});
      const res = await this.$api.pixel.get(this.storeId);
      this.$store.commit("sellerStore/setPixel", res?.data);
      this.createPixelClone();
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async mounted() {
    this.loadingFullPage = true;
    this.storeId = this.$route.params.id || "";
    //@ts-ignore
    this.tab = parseInt(this.$route.query.tab) || 0;
    await Promise.all([
      this.onGetDetailStore(),
      this.onGetPixcel(),
      this.onFilterByTime("Today"),
    ]);
    this.$store.dispatch("sellerStore/onGetDiscount", {
      ctx: this,
    });
    this.loadingFullPage = false;
    this.setDiscountToStore();
  }

  onFilterByTime(time: string) {
    this.$store.commit("setting/setFilterByTime", { time });
    this.onGetAllList();
  }

  async onGetAllList() {
    this.loadingTable = true;
    const proms = [this.onGetOrderList(), this.onGetStatStore()];
    await Promise.all(proms);
    this.loadingTable = false;
  }

  convertImage(url: string) {
    return `${api}/${url}`;
  }

  loadingTable = false;
  limit = 25;

  async onGetOrderList() {
    try {
      const query: any = {
        storeId: this.storeId,
        limit: this.config.limit,
        from: this.from,
        to: this.to,
        timezone: this.timezone,
      };
      const res = await this.$api.sellerOrder.list(query);
      if (res?.data) {
        const { total } = res.data;
        this.orderList = res?.data?.data;
        this.totalPage = Math.ceil(total / this.config.limit);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onGetDetailStore() {
    try {
      this.$store.commit("sellerStore/setStore", {});
      const res = await this.$api.store.detail(this.storeId);
      if (res?.data) {
        this.$store.commit("sellerStore/setStore", res.data);
        if (res.data?.store?.domain) {
          const subDomain = res.data.store.domain.split(".")[0];
          this.$store.commit("sellerStore/setSubDomain", subDomain);
          const mainDomain = res.data.store.domain.slice(subDomain.length + 1);
          this.$store.commit("sellerStore/setMainDomain", mainDomain);
          this.createStoreClone();
        }
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onGetStatStore() {
    try {
      const response = await this.$api.stats.statsStoreByTime({
        ...this.config,
        storeId: this.storeId,
        from: this.from,
        to: this.to,
        timezone: this.timezone,
      });
      if (response?.data) {
        this.$store.commit("manageStats/parseStats", response.data);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  @Watch("config.page")
  changedPage() {
    this.onGetDetailStore();
  }
}
</script>

<style src="./style.scss" lang="scss"></style>
